#include <legsdef.h>
#include "swinclude.h"
#include "swglobals.h"

do_bombs()
	{
	register struct mass *bomb, *massptr;
	register int oldx, oldy, bombit,notbombit;
	/* rip down the bomb list */
	for(bomb= b, bombit= 1, notbombit= ~1; bomb < bmax;
			++bomb, bombit <<= 1,(notbombit <<= 1),++notbombit)
		{
	/* Make the bombs orbit */
		oldx= bomb->scix;
		oldy= bomb->sciy;
		orbit(bomb);    /* this does all orbit calcualtions */
		bomb->scix = bomb->ix + BXOFF;
		bomb->sciy = bomb->iy + BYOFF;
	
		if(bomb->alive)
			{

			/* anything that gets REALLY close to the sun dies at once */
			if(bump(bomb,&THESUN,MINALT)) wound(bomb,1);
		
			/* the brackets here fix the infamous macros-in-ifs problem */
			if(bomb->well)
				{
				parmove(oldx,        oldy,
				bomb->scix,  bomb->sciy,
				15,          15,
					bomb->u.b.frame[bomb->theta]);
				}
			else
				{
				parmove(oldx,        oldy,
				bomb->scix,  bomb->sciy,
				31,          31,
					bomb->u.s.frame[bomb->theta]);
				}

			/* the radius of 10 allows the bombs to "sundive" somewhat */

			if(bomb->well && bump(bomb,&THESUN,10 + bomb->u.b.radius))
				{
/* the commented code breaks the compiler:
	its replacement is not as pretty, but it'll have to do */
/*				bomb->xvel= (bomb->ix>0 ? Bounce : -Bounce); */
				if(bomb->ix > 0)
					bomb->xvel= Bounce;
				else
					bomb->xvel= -Bounce;
/*				bomb->yvel= (bomb->iy>0 ? Bounce : -Bounce); */
				if(bomb->iy > 0)
					bomb->yvel= Bounce;
				else
					bomb->yvel= -Bounce;
				wound(bomb,FLASHTIME);
				}
			if(!--(bomb->clock))
				{
				/* it's timed out; clear its spot */

				bomb->alive=0;
				++(s[bomb->u.b.owner].u.s.bombcount);
				if(bomb->well)
					ras_put(bomb->scix,     bomb->sciy,
						15,             15,
						(bomb->u.b.frame)[bomb->theta],
						GXxor);
				else
					{
					ras_put(bomb->scix,     bomb->sciy,
						31,             31,
						(bomb->u.s.frame)[bomb->theta],
						GXxor);
				/* if this bomb has anyone in its collision sets, tell them */
					if(bomb->u.b.shipset)
						{
						bomb->u.b.shipset= 0;
						for(massptr=s; massptr<smax; ++massptr)
							massptr->u.s.bombset &= notbombit;
						}
					if(bomb->u.s.bombset)
						{
						bomb->u.s.bombset= 0;
						for(massptr=b; massptr<bmax; ++massptr)
							massptr->u.s.bombset &= notbombit;
						}
					}
				}
			else
				if(!(bomb->theta += bomb->ton))
					bomb->ton= 0xff;

		/* check for various bomb collisions */
			{register int notmassbit;

			/* Check for collisions between bombs */

				for(massptr= bomb+1, notmassbit= (notbombit << 1)+1;
						massptr < bmax;
						++massptr,(notmassbit <<= 1),++notmassbit)
					if(massptr->alive)
						if(bump(bomb,massptr,bomb->u.b.radius+massptr->u.b.radius))
							{
							if(!(bombit & (massptr->u.s.bombset)))
								bb_collide(bomb, massptr);
							}
						else
							{
							massptr->u.s.bombset &= notbombit;
							bomb->u.s.bombset &= notmassbit;
							};

			/* Check for collisions between ships and bombs */

				for(massptr= s, notmassbit= ~1;
						massptr < smax;
						++massptr,(notmassbit <<= 1),++notmassbit)
					if(massptr->alive)
						if(bump(bomb,massptr, 15 + bomb->u.b.radius))
							{
							if(!(bombit & (massptr->u.s.bombset)))
								bs_collide(bomb, massptr);
							}
						else
							{
							massptr->u.s.bombset &= notbombit;
							bomb->u.b.shipset &= notmassbit;
							};
				}
			}
		}
	}
