#include <legsdef.h>
/* generates a "movie" of concentric circles for use as explosions
	in spacewar */

/* integer scaling for bit coordinate locating */
#define MOFFSET 22

#define bit_on(iptr,x,y)\
	*(iptr+((x>0 ? 31:0) + y + 15)) |=\
		(x>0 ? (0x8000 >> (x-1)) : (1 << -x))

/* the sine table */
short sintab[256]= {
#include "sfile.h"
};

short sp[256][62];
short bp[256][15];

main()
	{
	int i;
	if(GXfind()) exit(1);	/* *&^%$#@! graphics board init! */

/* first create the small explosion for bomb use */
	boom(sp,0x700);

/* then use the magic screen hardware to cut it down to 15 * 15 */
	for(i=0;i<256;++i)
		{ras_put(300,300,31,31,sp[i],GXcopy);
		ras_get(308,308,15,15,bp[i],GXcopy);
		}

/* then write it out to the bombfile */
	i= creat("bombfile",0666);
	write(i,bp,sizeof(bp));
	close(i);

/* then make the real explosion movie and write that out */
	boom(sp,0xf00);
	i= creat("boomfile",0666);
	write(i,sp,sizeof(sp));
	close(i);
	}

boom(spinbuf,rmax) short rmax; register short spinbuf[][62];
	{
	unsigned char angle;
	short pointct,k;
	register int ax,ay,x,y;
	register short *imptr;
	register unsigned short radius,rmaxinc;

/* generate the spun images */
	srand(1);	/* initialize the random number generator */
	imptr= (short *) spinbuf - 62;
	angle= rand();
	rmaxinc= rmax/256;
		for(radius=rmaxinc; radius<=rmax; radius+= rmaxinc)
			{
			pointct= (radius >> 5) + 10;
			/* will be *(current image) */
			imptr+= 62;
			for(k=1; k<pointct; k++)
				{
				y=((radius*sintab[angle])>>(MOFFSET));
				x=((radius*sintab[angle+=64])>>(MOFFSET));
				ax= (x<0? -x : x);
				ay= (y<0? -y : y);
				if(!ax) ++ax;
				if(!ay) ++ay;
				angle += rand();
			/* x and y are coordinates of new dot */
			/* add fur for furry circles */
				if(x>0)
					x-= (rand()%ax);
				else if (x<0)
					x+= (rand()%ax);
				if(y>0)
					y-= (rand()%ay);
				else if (y<0)
					y+= (rand()%ay);
				if(x>=-15 && x<=15 && y>=-15 && y<=15)
					bit_on(imptr,x,y);
				}
			}
		}
