#include "swinclude.h"
#include "swglobals.h"

bb_collide(bomb, bomb2)
register struct mass *bomb, *bomb2;
	{
	float tx,ty;
	if(bomb->well)
		{
		/* the conditonal expression clips the explosion's length
		   to the remaining lifetime of the bomb */
	
		wound(bomb, MINIMUM(bomb->clock, Bdietime));
		bomb->u.b.radius= 15;
		}
	if(bomb2->well)
		{
		wound(bomb2, MINIMUM(bomb2->clock, Bdietime));
		bomb2->u.b.radius= 15;
		}
	
	/* make the bombs bounce off each other stickily */
		tx= bomb->xvel * Elasticity;
		ty= bomb->yvel * Elasticity;
		bomb->xvel= bomb2->xvel * Elasticity;
		bomb->yvel= bomb2->yvel * Elasticity;
		bomb2->xvel= tx;
		bomb2->yvel= ty;

	/* and make sure they don't hit each other again at once... */
		bomb->u.s.bombset |= (1 << (bomb2-b));
		bomb2->u.s.bombset |= (1 << (bomb-b));
	
	}
bs_collide(bomb, ship)
register struct mass *bomb, *ship;
	{
	float temp;

	/* Bomb to ship collision */
	/* first mung their velocities semi-elastically */
	/* this assumes center-of-mass collisions and may be ugly */
	temp= bomb->xvel - ship->xvel;
	bomb->xvel += (BombBounce * temp);
	ship->xvel += (ShipBounce * temp);
	temp= bomb->yvel - ship->yvel;
	bomb->yvel += (BombBounce * temp);
	ship->yvel += (ShipBounce * temp);

/* don't allow these two to collide again immediately... */
	ship->u.s.bombset |= (1 << (bomb-b));
	bomb->u.b.shipset |= (1 << (ship-s));

	if(ship->well)
		{
		wound(ship,Sdietime);

		/* adjust appropriate score here */
		/* old explosions are owned by nobody */

		if(bomb->well)
			if(bomb->u.b.owner == ship-s)
				{
				--(s[bomb->u.b.owner].u.s.roundscore);
				s[bomb->u.b.owner].suicide= 1;
				}
			else
				++(s[bomb->u.b.owner].u.s.roundscore);
		}
		/* the order of wellness testing is critical here;
		   only unwounded bombs cause score changes */
	if(bomb->well)
		{
		wound(bomb,MINIMUM(bomb->clock, Bdietime));
		bomb->u.b.radius= 15;
		}
	}

ss_collide(ship, ship2)
struct mass *ship, *ship2;
	{
	float txvel,tyvel;
	if(ship->well)  wound(ship,  Sdietime);
	if(ship2->well) wound(ship2, Sdietime);

	/* make the ship wreckage bounce off each other stickily */
		txvel= ship->xvel * Elasticity;
		tyvel= ship->yvel * Elasticity;
		ship->xvel= ship2->xvel * Elasticity;
		ship->yvel= ship2->yvel * Elasticity;
		ship2->xvel= txvel;
		ship2->yvel= tyvel;

	/* and make sure they don't hit each other immediately */
		ship->u.b.shipset |= (1 << (ship2-s));
		ship2->u.b.shipset |= (1 << (ship-s));
	}
