#include <math.h>
#include "swinclude.h"
#include "swglobals.h"

ship_init()
	{float theta;
	register struct mass *ship;
	register int i;

	/* reset live ship counter (tells us when game is over) */
	live_ships = ships;

	/* this brings all ships up facing out from the center
	   at radius INITR and tangential velocity Initv */

	for(i=0,ship= s; i<ships; ++i,++ship)
		{
		theta		= 2.*PI*i; theta/= ships;
		ship->ix	= ship->x	= INITR * cos(theta);
		ship->iy	= ship->y	= INITR * sin(theta);
		ship->scix 	= ship->ix + SXOFF;
		ship->sciy 	= ship->iy + SYOFF;
		ship->xvel	= -Initv * sin(theta);
		ship->yvel	= Initv * cos(theta);
		ship->theta	= theta * 128./PI;
		ship->xt	= t.thrust[(ship->theta+64)&255];
		ship->yt	= t.thrust[ship->theta];
		ship->u.s.frame	= ship_ras[i];
		ship->engineon	= 0;
		ship->alive	= 1;
		ship->well	= 1;
		ship->shooting	= 0;
		ship->cooling	= 0;
		ship->suicide	= 0;
		ship->ton	= 0;
		ship->u.s.roundscore= 0;
		ship->u.s.bombcount	= BOMBSPERSHIP;
	/* clear collision sets */
		ship->u.b.shipset= 0;
		ship->u.s.bombset= 0;
		}
	}

bomb_init()
	{register struct mass *bomb;

	for(bomb=b; bomb < bmax; ++bomb)
		{
	/* as long as bomb is not alive, almost nothing else matters */
		bomb->alive= 0;
	/* for computation timing, set all bombs "moving" */
		bomb->x= 0.;
		bomb->y= INITR;
		bomb->xvel= Initv;
		bomb->yvel = 0.;
		}
	}
