#include <stdio.h>

#define bit_on(iptr,x,y)\
	*(iptr+((x>0 ? 31:0) + y + 15)) |=\
		(x>0 ? (0x8000 >> (x-1)) : (1 << -x))

/* storage for ship under generation */
short sp[256][62];

main(argc,argv) int argc; char **argv;
	{
/* these definitions must be left alone or bit_on won't work */
	register short *spinbuf = (short *)sp;
	register int i,j,x,y;

	FILE *infile;	/* input file for ship pattern */

	if(argc != 3
	|| (infile= fopen(argv[1],"r"))==0
	|| (j= creat(argv[2],0666))<0)
		{
		printf("\tUsage: prepship <patternfile> <resultfile>\n");
		if(argc == 3) unlink(argv[2]);
		exit(1);
		}

/* files are all ok, now try to spin it */

	x= -15; y= 15;
	while((i= getc(infile)) != -1)
		{
		switch(i){
			case ' ': case '.':	/* the blank characters */
				++x; continue;
			case '\n':		/* newline - move down */
				--y; x= -15; continue;
			default:		/* anything else is a bit */
				if(y<-15 || x>15)	break;
				bit_on(spinbuf,x,y);
				++x;
				continue;
			}
/* we get here if there's a problem with the file */
		printf("Ship file has a point at %d %d\n",x,y);
		fclose(infile);
		unlink(argv[2]);
		exit(1);
		}
/* we get here after file is processed */

	spin(sp);	/* actually spin the file */
	if(write(j,sp,sizeof(sp)) != sizeof(sp))
		{
		printf("Trouble writing file %s\n",argv[2]);
		exit(1);
		}
	fclose(infile);
	close(j);
	}
