#include "swinclude.h"
#include <math.h>

main()
	{
	register int i;
	float sinval;

/* read in sun movie */
	if((i= open("boomfile",0)) < 0
	|| read(i,t.sun,sizeof(t.sun)) != sizeof(t.sun))
		{
		printf("Trouble reading boomfile\n");
		exit(1);
		}
	close(i);
/* read in explosion movie */
	if((i= open("boomfile",0)) < 0
	|| read(i,t.boom,sizeof(t.boom)) != sizeof(t.boom))
		{
		printf("Trouble reading boomfile 2\n");
		exit(1);
		}
	close(i);
/* read in engine flame movie */
	if((i= open("flamefile",0)) < 0
	|| read(i,t.flame,sizeof(t.flame)) != sizeof(t.flame))
		{
		printf("Trouble reading flamefile\n");
		exit(1);
		}
	close(i);
/* read in orbiting bomb movie */
	if((i= open("bombfile",0)) < 0
	|| read(i,t.bomb,sizeof(t.bomb)) != sizeof(t.bomb))
		{
		printf("Trouble reading bombfile\n");
		exit(1);
		}
	close(i);
/* create thrust tables */
	for(i=0;i<ANGLES;i++)
		{
		sinval= sin(i*(PI/128.));
		t.thrust[i]= ETHRUST*sinval;
		t.bdelp[i]= BDELP*sinval;
		t.bdelv[i]= BDELV*sinval;
		}
/* finally write out the table structure */
	i=creat("orbit.tables",0666);
	write(i,&t,sizeof(t));
	close(i);
	}
