#include "swinclude.h"
#include "swglobals.h"
#include "udvals.h"

/* the official way to define a control set */
/* l-left(ccw), r-right(cw), t-thrust, s-shoot */
#define controls(ship,l,r,t,s)\
		case r:\
				if(ship.ton)\
					ship.ton= 0;\
				else	ship.ton= -Turnrate;\
				break;\
		case l:\
				if(ship.ton)\
					ship.ton= 0;\
				else	ship.ton= Turnrate;\
				break;\
		case U(r):\
				if(ship.ton)\
					ship.ton= 0;\
				else	ship.ton= Turnrate;\
				break;\
		case U(l):\
				if(ship.ton)\
					ship.ton= 0;\
				else	ship.ton= -Turnrate;\
				break;\
		case t:\
				ship.engineon=1;\
				break;\
		case U(t):\
				ship.engineon=0;\
				break;\
		case s:\
				ship.shooting=1;\
				if(!ship.cooling)\
					{\
					ship.cooling= 1;\
					ship.clock= 1;\
					}\
				break;\
		case U(s):\
				ship.shooting= 0;\
				break

do_controls()
	{
	register unsigned char *udptr;
	ud_read(udkeybuf);
	if(*udkeybuf)
		for(udptr=udkeybuf;*udptr;++udptr)
			switch(*udptr)
			{
			controls(s[0],'z','x','c','v');
			controls(s[1],'m',',','.','/');
			controls(s[2],PADe,PADc,PADd,PF4);
	
			case 'q':    ud_quit(); exit();
		}
	}
