#include <stdio.h>
#include <math.h>
#include "swinclude.h"
#include "swglobals.h"

check_menu()
	{
	char reply;

	printf("change parameters? (y/n) ");
	do reply= getchar(); while(reply != 'y' && reply != 'n');

	if(reply=='y')
		{
		domenu();		       /* Modifies parameters and tables */
		}
	}

fixtables()
	{
	register int i;
	float sinval;

	Bounce    = sqrt(fabs(G) / 2000.)  * 2.0;     /* 2000. a good guess... */
	Initv     = sqrt(fabs(G) / 3000.0) * 1.5;     /* Seems a good guess... */
	ShipBounce = Elasticity * 2./(1. + ShipMass);
	BombBounce = Elasticity * (1.- ShipMass)/(1.+ ShipMass) - 1.;
	for(i=0;i<ANGLES;i++)
		{
		sinval= sin(i*(PI/128.));
		t.thrust[i]= Ethrust * sinval;
		t.bdelv [i]= Bdelv   * sinval;
		t.bdelp [i]= BDELP   * sinval;
		}
	}
