| Arguments: *mass, *mass, r, r**2
| Returns 1 if a collision (masses closer than r)
| I am assuming d0,d1,a0, and a1 are freely trashable
			IX=0
			IY=2

			.globl	_bump
_bump:
			movl	sp@(4),a0	| a0 -> mass1
			movl	sp@(8),a1	| a1 -> mass2
			movw	a0@(IX),d0	| First comupte deltax
			subw	a1@(IX),d0	| in d0
			bge		dxplus		| and make it positive
			negw	d0
dxplus:
			cmpw	sp@(14),d0	| If it's greater than r,
			bge		nobump		| no collision
			movw	a0@(IY),d1	| Now compute delta y
			subw	a1@(IY),d1	| the same way
			bge		dyplus
			negw	d1
dyplus:
			cmpw	sp@(14),d1
			bge		nobump
			muls	d0,d0		| OK, we'll have to do the
			muls	d1,d1		| multiplication and see
			addl	d1,d0		| (dx**2 + dy**2)
			movw	sp@(14),d1	| Get r
			muls	d1,d1		| and generate r**2
			cmpl	d1,d0		| Is it < R**2?
			bge		nobump
			moveq	#1,d0		| Yes, return 1
			rts
nobump:
			clrl	d0
			rts					| and return
